#include "BasicApplication.h"
#include "BasicWindow.h"
#include "consts.h"

#if B_ZETA_VERSION_BETA
	#include <locale/Locale.h>
#else
	#define _T(a) a
#endif 

BasicWindow::BasicWindow(BRect frame): BWindow(frame, "Hello", B_TITLED_WINDOW,0)
{
	Init();
}

status_t BasicWindow::Init()
{
	status_t err=B_OK;
	/*Variablen hier initialisieren (startwerte geben und anlegen)
	 ein eigene Methode Init hilft, falls Du mehrere Konstruktoren hast...
	 darin aber meist immer das selbe initalisieren musst.
	 status_t kann dazu dienen zu testen ob alles richtig gelaufen ist...
	 */
	 MakeMenu();
	 return err;
}

void BasicWindow::MakeMenu()
{
	BRect menuFrame		= Bounds();
	BMenuBar	*menuBar = new BMenuBar(menuFrame,"MenueBar");
	BMenuItem	*item;
	// build Filemenu
	BMenu *menu=new BMenu(_T("File"));
	item=new BMenuItem(_T("New"),new BMessage(MENU_FILE_NEW),'N');
	menu->AddItem(item);
	item=new BMenuItem(_T("Open"),new BMessage(MENU_FILE_OPEN),'O');
	// das heist die Naricht MENU_FILE_OPEN wird an BasicApplication geschickt
	item->SetTarget(be_app);
	menu->AddItem(item);

	menu->AddItem(new BMenuItem(_T("Close"),new BMessage(MENU_FILE_CLOSE),'W'));

	menu->AddSeparatorItem();

	item=new BMenuItem(_T("Save"), new BMessage(MENU_FILE_SAVE), 'S');
	item->SetEnabled(false);
	menu->AddItem(item);


	menu->AddItem(new BMenuItem(_T("Save As"),new BMessage(MENU_FILE_SAVEAS)));
	menu->AddSeparatorItem();
	item=new BMenuItem(_T("Page Setup"),new BMessage(MENU_FILE_PAGESETUP));
	item->SetEnabled(false);
	menu->AddItem(item);
	item=new BMenuItem(_T("Print"),new BMessage(MENU_FILE_PRINT), 'P');
	item->SetEnabled(false);
	menu->AddItem(item);

	menu->AddSeparatorItem();
	menu->AddItem(new BMenuItem(_T("Quit"), new BMessage(MENU_FILE_QUIT), 'Q'));
	menuBar->AddItem(menu);
	AddChild(menuBar);
}

bool BasicWindow::QuitRequested()
{
	// this is the old style, please use the new one
	// be_app->PostMessage(B_QUIT_REQUESTED);
	be_app_messenger.SendMessage(B_QUIT_REQUESTED);
	return(true);
}

void BasicWindow::MessageReceived(BMessage *message)
{
	switch(message->what) 
	{
		case MENU_FILE_NEW:
			{
				BRect r;
				r = Frame();
				//neues Fenster ein bischen nach unten schieben
				r.OffsetBy(20,20);
				BasicWindow *tmpWindow=new BasicWindow(r);
				AddChild(tmpWindow);
				tmpWindow->Show();				
			}
			break;
		case MENU_FILE_CLOSE:
			Quit();
			break;
		case MENU_FILE_QUIT:
			// this is the old way, please use the new one
			// be_app->PostMessage(B_QUIT_REQUESTED);
			be_app_messenger.SendMessage(B_QUIT_REQUESTED);
			break;
		case MENU_FILE_SAVEAS:
			//**savePanel->Show();
			break;
		case MENU_FILE_SAVE:
//			Save(NULL);
			break;
		case B_SAVE_REQUESTED:
//			Save(message);
			break;
		default:
			BWindow::MessageReceived(message);
			break;
	}
}
